"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configureAuthCommand = void 0;
const utils_1 = require("../utils");
const config_1 = require("../config");
const authenticate = async (currentToken) => {
    const config = new config_1.Config();
    await config.addAuthToken(currentToken);
    await (0, utils_1.event)({
        event: 'Cube Cloud CLI Authenticate'
    });
    console.log('Token successfully added!');
};
function configureAuthCommand(program) {
    program
        .command('auth <token>')
        .description('Authenticate access to Cube Cloud')
        .action((currentToken) => authenticate(currentToken)
        .catch(e => (0, utils_1.displayError)(e.stack || e)))
        .on('--help', () => {
        console.log('');
        console.log('Examples:');
        console.log('');
        console.log('  $ cubejs auth eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJkZXBsb3ltZW50SWQiOiIxIiwidXJsIjoiaHR0cHM6Ly9leGFtcGxlcy5jdWJlY2xvdWQuZGV2IiwiaWF0IjoxNTE2MjM5MDIyfQ.La3MiuqfGigfzADl1wpxZ7jlb6dY60caezgqIOoHt-c');
        console.log('  $ cubejs deploy');
    });
}
exports.configureAuthCommand = configureAuthCommand;
//# sourceMappingURL=auth.js.map