import { DateRange } from 'moment-range';
import { unitOfTime } from 'moment-timezone';
declare const Moment: any;
declare const moment: import("moment-range").MomentRange & typeof import("moment");
export type QueryDateRange = [string, string];
type SqlInterval = string;
export type TimeSeriesOptions = {
    timestampPrecision: number;
};
type ParsedInterval = Partial<Record<unitOfTime.DurationConstructor, number>>;
export declare const TIME_SERIES: Record<string, (range: DateRange, timestampPrecision: number) => QueryDateRange[]>;
/**
 * Parse PostgreSQL-like interval string into object
 * E.g. '2 years 15 months 100 weeks 99 hours 15 seconds'
 * Negative units are also supported
 * E.g. '-2 months 5 days -10 hours'
 */
export declare function parseSqlInterval(intervalStr: SqlInterval): ParsedInterval;
export declare function addInterval(date: moment.Moment, interval: ParsedInterval): moment.Moment;
export declare function subtractInterval(date: moment.Moment, interval: ParsedInterval): moment.Moment;
export declare const timeSeriesFromCustomInterval: (intervalStr: string, [startStr, endStr]: QueryDateRange, origin: moment.Moment, options?: TimeSeriesOptions) => QueryDateRange[];
/**
 * Returns array of date ranges for a predefined granularity aligned with the start of the year as pivot point
 */
export declare const timeSeries: (granularity: string, dateRange: QueryDateRange, options?: TimeSeriesOptions) => QueryDateRange[];
export declare const isPredefinedGranularity: (granularity: string) => boolean;
export declare const FROM_PARTITION_RANGE = "__FROM_PARTITION_RANGE";
export declare const TO_PARTITION_RANGE = "__TO_PARTITION_RANGE";
export declare const BUILD_RANGE_START_LOCAL = "__BUILD_RANGE_START_LOCAL";
export declare const BUILD_RANGE_END_LOCAL = "__BUILD_RANGE_END_LOCAL";
export declare const inDbTimeZone: (timezone: string, timestampFormat: string, timestamp: string) => string;
export declare const utcToLocalTimeZone: (timezone: string, timestampFormat: string, timestamp: string) => string;
export declare const extractDate: (data: any) => string | null;
export declare const addSecondsToLocalTimestamp: (timestamp: string, timezone: string, seconds: number) => Date;
export declare const reformatInIsoLocal: (timestamp: string) => string;
export {};
//# sourceMappingURL=time.d.ts.map